/*
 * Character.h
 *
 *  Created on: 28/mar/2012
 *      Author: bertini
 */

#ifndef CHARACTER_H_
#define CHARACTER_H_

#include "Weapon.h"

class Character {
public:
	Character(int hp=10, int d=10);
	virtual ~Character() {};

	bool operator==( const Character& right ) const;

	int getHP() const;
	void setHP(int strenght);
	Weapon* getWeapon() const;
	void setWeapon(Weapon* weapon);
	virtual int getArmor() const;
	void setArmor(int defense);

	virtual bool fight(Character& enemy) = 0;
	virtual int receiveDamage(int points) = 0;

protected:
	int HP;
	int armor;
	Weapon* weapon;
};

#endif /* CHARACTER_H_ */
