/*
 * EnvironmentElementAdapter.h
 *
 *  Created on: 31/mag/2012
 *      Author: bertini
 */

#ifndef ENVIRONMENTELEMENTADAPTER_H_
#define ENVIRONMENTELEMENTADAPTER_H_

#include "Character.h"

#include "EnviromentElement.h"

class EnvironmentElementAdapter: public Character {
public:
	EnvironmentElementAdapter(EnvironmentElement* adaptee) : envElem(adaptee) {
		setHP( adaptee->getRobustness() );
	};
	virtual ~EnvironmentElementAdapter() {};

	virtual int getArmor() const;

	virtual bool fight(Character& enemy);
	virtual int receiveDamage(int points);

private:
	EnvironmentElement* envElem;
};

#endif /* ENVIRONMENTELEMENTADAPTER_H_ */
