/*
 * Knight.h
 *
 *  Created on: 19/apr/2012
 *      Author: utente
 */

#ifndef KNIGHT_H_
#define KNIGHT_H_

#include "Character.h"

class Knight : public Character {
public:
	virtual ~Knight();
	Knight(int hp=20, int d=12, int ab = 6);
	Knight(const Knight& orig); // use virtual constructor idiom to handle copy of the pointer to abstract (Weapon) class
	Knight& operator=(const Knight& right); // Return ref for multiple assignment

	virtual bool fight(Character& enemy);
	virtual int receiveDamage(int points);

	void setAbility(int ab) {
		ability = ab;
	}
	int getAbility() const {
		return ability;
	}

private:
	int ability;

	void copier(const Knight& k);
};

#endif /* KNIGHT_H_ */
