/*
 * Character.cpp
 *
 *  Created on: 28/mar/2012
 *      Author: bertini
 */

#include "Character.h"

#include <ctime>
#include <cstdlib>
#include <iostream>

using namespace std;

Character::Character(int hp, int d) : HP(hp), armor(d) {
	srand( time(0) );
}

bool Character::operator ==( const Character& right ) const {
	if( HP != right.HP )
		return false;
	if( armor != right.armor )
		return false;

	return true;
}

int Character::getHP() const {
	return HP;
}

void Character::setHP(int hp) {
	this->HP = hp;
}

Weapon* Character::getWeapon() const {
	return weapon;
}

void Character::setWeapon(Weapon* weapon) {
	this->weapon = weapon;
}

int Character::getArmor() const {
	return armor;
}

void Character::setArmor(int defense) {
	this->armor = defense;
}






