/*
 * EnviromentElement.h
 *
 *  Created on: 30/mag/2012
 *      Author: bertini
 */

#ifndef ENVIROMENTELEMENT_H_
#define ENVIROMENTELEMENT_H_

class EnvironmentElement {
public:
	EnvironmentElement(int aX, int aY, int strenght = 4, bool fragile = false) : x(aX), y(aY), robustness(strenght), breakable(fragile) {};
	virtual ~EnvironmentElement() = 0; // pure virtual destructor

	bool isBreakable() const {
		return breakable;
	}

	void setBreakable(bool breakable) {
		this->breakable = breakable;
	}

	int getRobustness() const {
		return robustness;
	}

	void setRobustness(int robustness) {
		this->robustness = robustness;
	}

protected:
	int x,y;
	int robustness;
	bool breakable;
};


#endif /* ENVIROMENTELEMENT_H_ */
