/*
 * MeleeWeapon.h
 *
 *  Created on: 19/apr/2012
 *      Author: bertini
 */

#ifndef MELEEWEAPON_H_
#define MELEEWEAPON_H_

#include "Weapon.h"

class MeleeWeapon : public Weapon {
public:
	explicit MeleeWeapon(int st=10, bool ma=false);
	virtual ~MeleeWeapon();

	virtual int useWeapon();
	virtual MeleeWeapon* clone() const; // Covariant return type: an overridden method in a derived class can return a type derived from the type returned by the base-class method.

	bool isMagic() const;
	void setMagic(bool magic);

private:
	bool magic;

	int computeHit();
};

#endif /* MELEEWEAPON_H_ */
