/*
 * MissileWeapon.h
 *
 *  Created on: 19/apr/2012
 *      Author: bertini
 */

#ifndef MISSILEWEAPON_H_
#define MISSILEWEAPON_H_

#include "Weapon.h"

class MissileWeapon: public Weapon {
public:
	explicit MissileWeapon(int st=10, int mis=12);
	virtual ~MissileWeapon();

	virtual int useWeapon();
	virtual MissileWeapon* clone() const; // Covariant return type: an overridden method in a derived class can return a type derived from the type returned by the base-class method.

	int getMissiles() const;
	void setMissiles(int missiles);

private:
	int missiles;
};

#endif /* MISSILEWEAPON_H_ */
