/*
 * MovEnvElementAdapter.h
 *
 *  Created on: 30/mag/2012
 *      Author: bertini
 */

#ifndef MOVENVELEMENTADAPTER_H_
#define MOVENVELEMENTADAPTER_H_

#include "MovableEnvironmentElement.h"
#include "Monster.h"
#include "Character.h"

class MovEnvElementAdapter: private MovableEnvironmentElement, public Monster {
public:
	MovEnvElementAdapter(const MovableEnvironmentElement& adaptee);
	virtual ~MovEnvElementAdapter();

	virtual int getArmor() const;

	virtual bool fight(Character& enemy);
	virtual int receiveDamage(int points);
};

#endif /* MOVENVELEMENTADAPTER_H_ */
